/*
 * emu68k.c
 *
 * emulation of the 68000
 */

/* $Id: emu68k.c,v 1.31 1999/12/27 00:58:52 nyef Exp $ */

#include <stdlib.h>
#include "cal.h"
#include "ui.h"
#include "emu68k.h"
#include "tool.h"
#include "types.h"

/*  #define USE_UNTESTED */

typedef void (*m68k_instr_handler)(struct emu68k_context *, u16);

extern struct m68k_instr m68k_grp_0[]; extern struct m68k_instr m68k_grp_1[];
extern struct m68k_instr m68k_grp_2[]; extern struct m68k_instr m68k_grp_3[];
extern struct m68k_instr m68k_grp_4[]; extern struct m68k_instr m68k_grp_5[];
extern struct m68k_instr m68k_grp_6[]; extern struct m68k_instr m68k_grp_7[];
extern struct m68k_instr m68k_grp_8[]; extern struct m68k_instr m68k_grp_9[];
extern struct m68k_instr m68k_grp_a[]; extern struct m68k_instr m68k_grp_b[];
extern struct m68k_instr m68k_grp_c[]; extern struct m68k_instr m68k_grp_d[];
extern struct m68k_instr m68k_grp_e[]; extern struct m68k_instr m68k_grp_f[];

void m68k_do_SUBI_byte(struct emu68k_context *context, u16 opword);
void m68k_do_SUBI_word(struct emu68k_context *context, u16 opword);
void m68k_do_SUBI_long(struct emu68k_context *context, u16 opword);
void m68k_do_ADDI_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ADDI_word(struct emu68k_context *context, u16 opword);
void m68k_do_ADDI_long(struct emu68k_context *context, u16 opword);
void m68k_do_ANDI_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ANDI_word(struct emu68k_context *context, u16 opword);
void m68k_do_ANDI_long(struct emu68k_context *context, u16 opword);
void m68k_do_AND_d_byte(struct emu68k_context *context, u16 opword);
void m68k_do_AND_d_word(struct emu68k_context *context, u16 opword);
void m68k_do_AND_d_long(struct emu68k_context *context, u16 opword);
void m68k_do_AND_e_byte(struct emu68k_context *context, u16 opword);
void m68k_do_AND_e_word(struct emu68k_context *context, u16 opword);
void m68k_do_AND_e_long(struct emu68k_context *context, u16 opword);
void m68k_do_ORI_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ORI_word(struct emu68k_context *context, u16 opword);
void m68k_do_ORI_long(struct emu68k_context *context, u16 opword);
void m68k_do_OR_d_byte(struct emu68k_context *context, u16 opword);
void m68k_do_OR_d_word(struct emu68k_context *context, u16 opword);
void m68k_do_OR_d_long(struct emu68k_context *context, u16 opword);
void m68k_do_OR_e_byte(struct emu68k_context *context, u16 opword);
void m68k_do_OR_e_word(struct emu68k_context *context, u16 opword);
void m68k_do_OR_e_long(struct emu68k_context *context, u16 opword);
void m68k_do_CMPI_byte(struct emu68k_context *context, u16 opword);
void m68k_do_CMPI_word(struct emu68k_context *context, u16 opword);
void m68k_do_CMPI_long(struct emu68k_context *context, u16 opword);
void m68k_do_CMP_byte(struct emu68k_context *context, u16 opword);
void m68k_do_CMP_word(struct emu68k_context *context, u16 opword);
void m68k_do_CMP_long(struct emu68k_context *context, u16 opword);
void m68k_do_EOR_byte(struct emu68k_context *context, u16 opword);
void m68k_do_EOR_word(struct emu68k_context *context, u16 opword);
void m68k_do_EOR_long(struct emu68k_context *context, u16 opword);
void m68k_do_NOT_byte(struct emu68k_context *context, u16 opword);
void m68k_do_NOT_word(struct emu68k_context *context, u16 opword);
void m68k_do_NOT_long(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_byte(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_word(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_long(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEA_word(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEA_long(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEQ(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEM_RM_word(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEM_RM_long(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEM_MR_word(struct emu68k_context *context, u16 opword);
void m68k_do_MOVEM_MR_long(struct emu68k_context *context, u16 opword);
void m68k_do_CLR_byte(struct emu68k_context *context, u16 opword);
void m68k_do_CLR_word(struct emu68k_context *context, u16 opword);
void m68k_do_CLR_long(struct emu68k_context *context, u16 opword);
void m68k_do_TST_byte(struct emu68k_context *context, u16 opword);
void m68k_do_TST_word(struct emu68k_context *context, u16 opword);
void m68k_do_TST_long(struct emu68k_context *context, u16 opword);
void m68k_do_TAS(struct emu68k_context *context, u16 opword);
void m68k_do_BRA(struct emu68k_context *context, u16 opword);
void m68k_do_BSR(struct emu68k_context *context, u16 opword);
void m68k_do_BCC(struct emu68k_context *context, u16 opword);
void m68k_do_BCS(struct emu68k_context *context, u16 opword);
void m68k_do_BNE(struct emu68k_context *context, u16 opword);
void m68k_do_BEQ(struct emu68k_context *context, u16 opword);
void m68k_do_BPL(struct emu68k_context *context, u16 opword);
void m68k_do_BMI(struct emu68k_context *context, u16 opword);
void m68k_do_LEA(struct emu68k_context *context, u16 opword);
void m68k_do_DBF(struct emu68k_context *context, u16 opword);
void m68k_do_SF(struct emu68k_context *context, u16 opword);
void m68k_do_BTST_dyn(struct emu68k_context *context, u16 opword);
void m68k_do_BTST_stat(struct emu68k_context *context, u16 opword);
void m68k_do_SUB_reg_byte(struct emu68k_context *context, u16 opword);
void m68k_do_SUB_reg_word(struct emu68k_context *context, u16 opword);
void m68k_do_SUBA_word(struct emu68k_context *context, u16 opword);
void m68k_do_SUBA_long(struct emu68k_context *context, u16 opword);
void m68k_do_SUBQ_byte(struct emu68k_context *context, u16 opword);
void m68k_do_SUBQ_word(struct emu68k_context *context, u16 opword);
void m68k_do_SUBQ_long(struct emu68k_context *context, u16 opword);
void m68k_do_SUBQ_An(struct emu68k_context *context, u16 opword);
void m68k_do_ADD_d_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ADD_d_word(struct emu68k_context *context, u16 opword);
void m68k_do_ADD_d_long(struct emu68k_context *context, u16 opword);
void m68k_do_ADD_e_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ADD_e_word(struct emu68k_context *context, u16 opword);
void m68k_do_ADD_e_long(struct emu68k_context *context, u16 opword);
void m68k_do_ADDA_word(struct emu68k_context *context, u16 opword);
void m68k_do_ADDQ_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ADDQ_word(struct emu68k_context *context, u16 opword);
void m68k_do_ADDQ_long(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_to_CCR(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_to_SR(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_from_SR(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_to_USP(struct emu68k_context *context, u16 opword);
void m68k_do_MOVE_from_USP(struct emu68k_context *context, u16 opword);
void m68k_do_RTS(struct emu68k_context *context, u16 opword);
void m68k_do_RTE(struct emu68k_context *context, u16 opword);
void m68k_do_NOP(struct emu68k_context *context, u16 opword);
void m68k_do_JMP(struct emu68k_context *context, u16 opword);
void m68k_do_JSR(struct emu68k_context *context, u16 opword);
void m68k_do_LINK(struct emu68k_context *context, u16 opword);
void m68k_do_UNLK(struct emu68k_context *context, u16 opword);
void m68k_do_LSR_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_LSR_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_LSR_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_LSR_m(struct emu68k_context *context, u16 opword);
void m68k_do_ASR_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ASR_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_ASR_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_ASR_m(struct emu68k_context *context, u16 opword);
void m68k_do_LSL_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_LSL_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_LSL_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_LSL_m(struct emu68k_context *context, u16 opword);
void m68k_do_ROL_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ROL_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_ROL_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_ROL_m(struct emu68k_context *context, u16 opword);
void m68k_do_ROR_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ROR_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_ROR_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_ROR_m(struct emu68k_context *context, u16 opword);
void m68k_do_ROXL_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ROXL_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_ROXL_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_ROXL_m(struct emu68k_context *context, u16 opword);
void m68k_do_ROXR_r_byte(struct emu68k_context *context, u16 opword);
void m68k_do_ROXR_r_word(struct emu68k_context *context, u16 opword);
void m68k_do_ROXR_r_long(struct emu68k_context *context, u16 opword);
void m68k_do_ROXR_m(struct emu68k_context *context, u16 opword);
void m68k_do_alinetrap(struct emu68k_context *context, u16 opword);
void m68k_do_flinetrap(struct emu68k_context *context, u16 opword);
void m68k_do_unimp(struct emu68k_context *context, u16 opword);

struct m68k_instr {
    u16 mask;
    u16 pattern;
    m68k_instr_handler handler;
    char *name;
};

struct m68k_instr *m68k_instrs[16] = {
    m68k_grp_0, m68k_grp_1, m68k_grp_2, m68k_grp_3,
    m68k_grp_4, m68k_grp_5, m68k_grp_6, m68k_grp_7,
    m68k_grp_8, m68k_grp_9, m68k_grp_a, m68k_grp_b,
    m68k_grp_c, m68k_grp_d, m68k_grp_e, m68k_grp_f,
};

struct m68k_instr m68k_grp_0[] = {
#ifdef USE_UNTESTED
    {0x0fc0, 0x0000, m68k_do_ORI_byte, "ORI.B"},
    {0x0fc0, 0x0040, m68k_do_ORI_word, "ORI.W"},
    {0x0fc0, 0x0080, m68k_do_ORI_long, "ORI.L"},
#endif
    {0x0fc0, 0x0200, m68k_do_ANDI_byte, "ANDI.B"},
    {0x0fc0, 0x0240, m68k_do_ANDI_word, "ANDI.W"},
    {0x0fc0, 0x0280, m68k_do_ANDI_long, "ANDI.L"},
#ifdef USE_UNTESTED
    {0x0fc0, 0x0400, m68k_do_SUBI_byte, "SUBI.B"},
    {0x0fc0, 0x0440, m68k_do_SUBI_word, "SUBI.W"},
    {0x0fc0, 0x0480, m68k_do_SUBI_long, "SUBI.L"},
    {0x0fc0, 0x0600, m68k_do_ADDI_byte, "ADDI.B"},
    {0x0fc0, 0x0640, m68k_do_ADDI_word, "ADDI.W"},
    {0x0fc0, 0x0680, m68k_do_ADDI_long, "ADDI.L"},
#endif
    {0x0fc0, 0x0800, m68k_do_BTST_stat, "BTST-S"},
#ifdef USE_UNTESTED
    {0x0fc0, 0x0c00, m68k_do_CMPI_byte, "CMPI.B"},
    {0x0fc0, 0x0c40, m68k_do_CMPI_word, "CMPI.W"},
    {0x0fc0, 0x0c80, m68k_do_CMPI_long, "CMPI.L"},
#endif
    {0x01c0, 0x0100, m68k_do_BTST_dyn, "BTST-D"},
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_1[] = {
    {0x0000, 0x0000, m68k_do_MOVE_byte, "MOVE.B"},
};

struct m68k_instr m68k_grp_2[] = {
    {0x01c0, 0x0040, m68k_do_MOVEA_long, "MOVEA.L"},
    {0x0000, 0x0000, m68k_do_MOVE_long, "MOVE.L"},
};

struct m68k_instr m68k_grp_3[] = {
    {0x01c0, 0x0040, m68k_do_MOVEA_word, "MOVEA.W"},
    {0x0000, 0x0000, m68k_do_MOVE_word, "MOVE.W"},
};

struct m68k_instr m68k_grp_4[] = {
    {0x0fff, 0x0e71, m68k_do_NOP, "NOP"},
    {0x0fff, 0x0e73, m68k_do_RTE, "RTE"},
    {0x0fff, 0x0e75, m68k_do_RTS, "RTS"},
    {0x0ff8, 0x0e50, m68k_do_LINK, "LINK"},
    {0x0ff8, 0x0e58, m68k_do_UNLK, "UNLK"},
    {0x0ff8, 0x0e60, m68k_do_MOVE_to_USP, "MOVE to USP"},
#ifdef USE_UNTESTED
    {0x0ff8, 0x0e68, m68k_do_MOVE_from_USP, "MOVE from USP"},
#endif
    {0x0fc0, 0x00c0, m68k_do_MOVE_from_SR, "MOVE from SR"},
    {0x0fc0, 0x0200, m68k_do_CLR_byte, "CLR.B"},
    {0x0fc0, 0x0240, m68k_do_CLR_word, "CLR.W"},
    {0x0fc0, 0x0280, m68k_do_CLR_long, "CLR.L"},
    {0x0fc0, 0x04c0, m68k_do_MOVE_to_CCR, "MOVE to CCR"},
    {0x0fc0, 0x0600, m68k_do_NOT_byte, "NOT.B"},
    {0x0fc0, 0x0640, m68k_do_NOT_word, "NOT.W"},
    {0x0fc0, 0x0680, m68k_do_NOT_long, "NOT.L"},
    {0x0fc0, 0x06c0, m68k_do_MOVE_to_SR, "MOVE to SR"},
    {0x0fc0, 0x0880, m68k_do_MOVEM_RM_word, "MOVEM.W"},
    {0x0fc0, 0x08c0, m68k_do_MOVEM_RM_long, "MOVEM.L"},
    {0x0fc0, 0x0a00, m68k_do_TST_byte, "TST.B"},
    {0x0fc0, 0x0a40, m68k_do_TST_word, "TST.W"},
    {0x0fc0, 0x0a80, m68k_do_TST_long, "TST.L"},
#ifdef USE_UNTESTED
    {0x0fc0, 0x0ac0, m68k_do_TAS, "TAS"},
#endif
    {0x0fc0, 0x0c80, m68k_do_MOVEM_MR_word, "MOVEM.W"},
    {0x0fc0, 0x0cc0, m68k_do_MOVEM_MR_long, "MOVEM.L"},
    {0x0fc0, 0x0e80, m68k_do_JSR, "JSR"},
    {0x0fc0, 0x0ec0, m68k_do_JMP, "JMP"},
    {0x01c0, 0x01c0, m68k_do_LEA, "LEA"},
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_5[] = {
    /* FIXME: DBcc instructions come first */
    {0x0ff8, 0x01c8, m68k_do_DBF, "DBF"},
#ifdef USE_UNTESTED
    {0x0fc0, 0x01c0, m68k_do_SF, "SF"},
    {0x01c0, 0x0000, m68k_do_ADDQ_byte, "ADDQ.B"},
#endif
    {0x01c0, 0x0040, m68k_do_ADDQ_word, "ADDQ.W"},
#ifdef USE_UNTESTED
    {0x01c0, 0x0080, m68k_do_ADDQ_long, "ADDQ.L"},
#endif
    {0x01c0, 0x0100, m68k_do_SUBQ_byte, "SUBQ.B"},
    {0x01f8, 0x0148, m68k_do_SUBQ_An, "SUBQ.W"},
    {0x01c0, 0x0140, m68k_do_SUBQ_word, "SUBQ.W"},
    {0x01f8, 0x0188, m68k_do_SUBQ_An, "SUBQ.L"},
#ifdef USE_UNTESTED
    {0x01c0, 0x0180, m68k_do_SUBQ_long, "SUBQ.L"},
#endif
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_6[] = {
    {0x0f00, 0x0000, m68k_do_BRA, "BRA"},
    {0x0f00, 0x0100, m68k_do_BSR, "BSR"},
    {0x0f00, 0x0400, m68k_do_BCC, "BCC"},
    {0x0f00, 0x0500, m68k_do_BCS, "BCS"},
    {0x0f00, 0x0600, m68k_do_BNE, "BNE"},
    {0x0f00, 0x0700, m68k_do_BEQ, "BEQ"},
    {0x0f00, 0x0a00, m68k_do_BPL, "BPL"},
    {0x0f00, 0x0b00, m68k_do_BMI, "BMI"},
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_7[] = {
    {0x0100, 0x0000, m68k_do_MOVEQ, "MOVEQ"},
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_8[] = {
#ifdef USE_UNTESTED
    {0x01c0, 0x0000, m68k_do_OR_d_byte, "OR.B"},
    {0x01c0, 0x0040, m68k_do_OR_d_word, "OR.W"},
    {0x01c0, 0x0080, m68k_do_OR_d_long, "OR.L"},
    {0x01c0, 0x0100, m68k_do_OR_e_byte, "OR.B"},
    {0x01c0, 0x0140, m68k_do_OR_e_word, "OR.W"},
    {0x01c0, 0x0180, m68k_do_OR_e_long, "OR.L"},
#endif
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_9[] = {
    {0x01c0, 0x0000, m68k_do_SUB_reg_byte, "SUB.B"},
    {0x01c0, 0x0040, m68k_do_SUB_reg_word, "SUB.W"},
    {0x01c0, 0x00c0, m68k_do_SUBA_word, "SUBA.W"},
    {0x01c0, 0x01c0, m68k_do_SUBA_long, "SUBA.L"},
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_a[] = {
    {0x0000, 0x0000, m68k_do_alinetrap, "A-TRAP"},
};

struct m68k_instr m68k_grp_b[] = {
    {0x01c0, 0x0000, m68k_do_CMP_byte, "CMP.B"},
    {0x01c0, 0x0040, m68k_do_CMP_word, "CMP.W"},
    {0x01c0, 0x0080, m68k_do_CMP_long, "CMP.L"},
    {0x01c0, 0x0100, m68k_do_EOR_byte, "EOR.B"},
    {0x01c0, 0x0140, m68k_do_EOR_word, "EOR.W"},
    {0x01c0, 0x0180, m68k_do_EOR_long, "EOR.L"},
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_c[] = {
#ifdef USE_UNTESTED
    {0x01c0, 0x0000, m68k_do_AND_d_byte, "AND.B"},
#endif
    {0x01c0, 0x0040, m68k_do_AND_d_word, "AND.W"},
    {0x01c0, 0x0080, m68k_do_AND_d_long, "AND.L"},
#ifdef USE_UNTESTED
    {0x01c0, 0x0100, m68k_do_AND_e_byte, "AND.B"},
    {0x01c0, 0x0140, m68k_do_AND_e_word, "AND.W"},
    {0x01c0, 0x0180, m68k_do_AND_e_long, "AND.L"},
#endif
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_d[] = {
    {0x01c0, 0x0000, m68k_do_ADD_d_byte, "ADD.B"},
    {0x01c0, 0x0040, m68k_do_ADD_d_word, "ADD.W"},
    {0x01c0, 0x0080, m68k_do_ADD_d_long, "ADD.L"},
    {0x01c0, 0x00c0, m68k_do_ADDA_word, "ADDA.W"},
    {0x01c0, 0x0100, m68k_do_ADD_e_byte, "ADD.B"},
    {0x01c0, 0x0140, m68k_do_ADD_e_word, "ADD.W"},
#ifdef USE_UNTESTED
    {0x01c0, 0x0180, m68k_do_ADD_e_long, "ADD.L"},
#endif
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_e[] = {
#ifdef USE_UNTESTED
    {0x1d8, 0x0000, m68k_do_ASR_r_byte},
#endif
    {0x1d8, 0x0040, m68k_do_ASR_r_word},
    {0x1d8, 0x0080, m68k_do_ASR_r_long},
#if USE_UNTESTED
    {0xfc0, 0x00c0, m68k_do_ASR_m},
    {0x1d8, 0x0100, m68k_do_LSL_r_byte}, /* ASL */
#endif
    {0x1d8, 0x0140, m68k_do_LSL_r_word}, /* ASL */
    {0x1d8, 0x0180, m68k_do_LSL_r_long}, /* ASL */
#ifdef USE_UNTESTED
    {0xfc0, 0x01c0, m68k_do_LSL_m}, /* ASL */
    {0x1d8, 0x0008, m68k_do_LSR_r_byte},
#endif
    {0x1d8, 0x0048, m68k_do_LSR_r_word},
    {0x1d8, 0x0088, m68k_do_LSR_r_long},
#ifdef USE_UNTESTED
    {0xfc0, 0x02c0, m68k_do_LSR_m},
    {0x1d8, 0x0108, m68k_do_LSL_r_byte},
#endif
    {0x1d8, 0x0148, m68k_do_LSL_r_word},
    {0x1d8, 0x0188, m68k_do_LSL_r_long},
#ifdef USE_UNTESTED
    {0xfc0, 0x03c0, m68k_do_LSL_m},
    {0x1d8, 0x0010, m68k_do_ROXR_r_byte},
    {0x1d8, 0x0050, m68k_do_ROXR_r_word},
    {0x1d8, 0x0090, m68k_do_ROXR_r_long},
    {0xfc0, 0x04c0, m68k_do_ROXR_m},
    {0x1d8, 0x0110, m68k_do_ROXL_r_byte},
    {0x1d8, 0x0150, m68k_do_ROXL_r_word},
    {0x1d8, 0x0190, m68k_do_ROXL_r_long},
    {0xfc0, 0x05c0, m68k_do_ROXL_m},
    {0x1d8, 0x0018, m68k_do_ROR_r_byte},
    {0x1d8, 0x0058, m68k_do_ROR_r_word},
    {0x1d8, 0x0098, m68k_do_ROR_r_long},
    {0xfc0, 0x06c0, m68k_do_ROR_m},
    {0x1d8, 0x0118, m68k_do_ROL_r_byte},
    {0x1d8, 0x0158, m68k_do_ROL_r_word},
    {0x1d8, 0x0198, m68k_do_ROL_r_long},
    {0xfc0, 0x07c0, m68k_do_ROL_m},
#endif
    {0x0000, 0x0000, m68k_do_unimp, "<unimp>"},
};

struct m68k_instr m68k_grp_f[] = {
    {0x0000, 0x0000, m68k_do_flinetrap, "F-TRAP"},
};

u8 emu68k_read_8(struct emu68k_context *context, u32 addr)
{
    context->cycles_left -= 4;
    
    return context->read8table[(addr >> context->memshift)
			      & context->memmask](context->cpu, addr);
}

u16 emu68k_read_16(struct emu68k_context *context, u32 addr)
{
    /* FIXME: BUS error check goes here */

    context->cycles_left -= 4;
    
    return context->read16table[(addr >> context->memshift)
			       & context->memmask](context->cpu, addr);
}

u32 emu68k_read_32(struct emu68k_context *context, u32 addr)
{
    u16 tmp1;
    u16 tmp2;
    
    /* FIXME: BUS error check goes here */

    /* FIXME: check if this is the correct order */
    tmp1 = emu68k_read_16(context, addr);
    tmp2 = emu68k_read_16(context, addr + 2);

    return (tmp1 << 16) | tmp2;
}

void emu68k_write_8(struct emu68k_context *context, u32 addr, u8 data)
{
    context->cycles_left -= 4;
    
    context->write8table[(addr >> context->memshift)
			& context->memmask](context->cpu, addr, data);
}

void emu68k_write_16(struct emu68k_context *context, u32 addr, u16 data)
{
    /* FIXME: BUS error check goes here */
    
    context->cycles_left -= 4;
    
    context->write16table[(addr >> context->memshift)
			& context->memmask](context->cpu, addr, data);
}

void emu68k_write_32(struct emu68k_context *context, u32 addr, u32 data)
{
    /* FIXME: BUS error check goes here */

    /* FIXME: check if this is the correct order */
    emu68k_write_16(context, addr, data >> 16);
    emu68k_write_16(context, addr + 2, data & 0xffff);
}

u16 emu68k_opfetch_16(struct emu68k_context *context)
{
    u16 retval;

    retval = emu68k_read_16(context, context->pc);
    context->pc += 2;

    return retval;
}

u32 emu68k_opfetch_32(struct emu68k_context *context)
{
    u32 retval;

    retval = emu68k_read_32(context, context->pc);
    context->pc += 4;

    return retval;
}

void emu68k_step(struct emu68k_context *context)
{
    u16 opword;
    struct m68k_instr *cur_instr;
    
    if (context->pc & 1) {
	/* FIXME: bad things happen here */
    }
    opword = emu68k_opfetch_16(context);
    cur_instr = m68k_instrs[opword >> 12];
    while ((opword & cur_instr->mask) != cur_instr->pattern) {
	cur_instr++;
    }
    cur_instr->handler(context, opword);
}

void emu68k_reset(struct emu68k_context *context)
{
    context->regs_a[7] = emu68k_read_32(context, 0);
    
    context->pc = emu68k_read_32(context, 4);

    context->flags = 0x2000; /* FIXME: may be wrong */
}

#define AMT_DATA      0x1
#define AMT_MEMORY    0x2
#define AMT_CONTROL   0x4
#define AMT_ALTERABLE 0x8

#define AMT_DA (AMT_DATA | AMT_ALTERABLE)
#define AMT_MA (AMT_MEMORY | AMT_ALTERABLE)
#define AMT_CA (AMT_CONTROL | AMT_ALTERABLE)

#define AMODE_IS(amode, am_type) ((amode.type & am_type) == am_type)

struct m68k_amode {
    u8 type;
    u32 data;
    u32 flags;
    int reg;
    struct emu68k_context *context;
    struct m68k_amode_api *api;
};

extern struct m68k_amode_api m68k_amode_api_0;
extern struct m68k_amode_api m68k_amode_api_1;
extern struct m68k_amode_api m68k_amode_api_2;
extern struct m68k_amode_api m68k_amode_api_3;
extern struct m68k_amode_api m68k_amode_api_4;
extern struct m68k_amode_api m68k_amode_api_5;
extern struct m68k_amode_api m68k_amode_api_6;
extern struct m68k_amode_api m68k_amode_api_7;
extern struct m68k_amode_api m68k_amode_api_8;
extern struct m68k_amode_api m68k_amode_api_9;
extern struct m68k_amode_api m68k_amode_api_10;
extern struct m68k_amode_api m68k_amode_api_11;

struct m68k_amode m68k_amodes[] = {
    {0x09, 0, 0, 0, NULL, &m68k_amode_api_0},  /* Dn */
    {0x08, 0, 0, 0, NULL, &m68k_amode_api_1},  /* An */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_2},  /* (An) */
    {0x0b, 0, 0, 0, NULL, &m68k_amode_api_3},  /* (An)+ */
    {0x0b, 0, 0, 0, NULL, &m68k_amode_api_4},  /* -(An) */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_5},  /* d(An) */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_6},  /* d(An,Ri) */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_7},  /* xxxx */
    {0x0f, 0, 0, 0, NULL, &m68k_amode_api_8},  /* xxxxxxxx */
    {0x07, 0, 0, 0, NULL, &m68k_amode_api_9},  /* d */
    {0x07, 0, 0, 0, NULL, &m68k_amode_api_10}, /* d(Ri) */
    {0x03, 0, 0, 0, NULL, &m68k_amode_api_11}, /* #xxxx */
    {0x00, 0, 0, 0, NULL, NULL},               /* <invalid> */
};

typedef void (*m68k_amode_resolver)(struct m68k_amode *, struct emu68k_context *, int);
typedef u8 (*m68k_amode_read_byte)(struct m68k_amode *);
typedef u16 (*m68k_amode_read_word)(struct m68k_amode *);
typedef u32 (*m68k_amode_read_long)(struct m68k_amode *);
typedef void (*m68k_amode_write_byte)(struct m68k_amode *, u8);
typedef void (*m68k_amode_write_word)(struct m68k_amode *, u16);
typedef void (*m68k_amode_write_long)(struct m68k_amode *, u32);
typedef void (*m68k_amode_after)(struct m68k_amode *);

struct m68k_amode_api {
    m68k_amode_resolver resolve;
    m68k_amode_read_byte readbyte;
    m68k_amode_read_word readword;
    m68k_amode_read_long readlong;
    m68k_amode_write_byte writebyte;
    m68k_amode_write_word writeword;
    m68k_amode_write_long writelong;
    m68k_amode_after after;
};

#define AMS_BOGUS 0
#define AMS_BYTE 1
#define AMS_WORD 2
#define AMS_LONG 3

void m68k_amode_none_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    deb_printf("m68k: unimplemented amode (api: 0x%08x).\n", amode->api);
    system_flags |= F_UNIMPL;
}

void m68k_amode_0_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
}

u8 m68k_amode_0_readbyte(struct m68k_amode *amode)
{
    return (u8)amode->context->regs_d[amode->reg];
}

u16 m68k_amode_0_readword(struct m68k_amode *amode)
{
    return (u16)amode->context->regs_d[amode->reg];
}

u32 m68k_amode_0_readlong(struct m68k_amode *amode)
{
    return amode->context->regs_d[amode->reg];
}

void m68k_amode_0_writebyte(struct m68k_amode *amode, u8 data)
{
    amode->context->regs_d[amode->reg] &= ~0xff;
    amode->context->regs_d[amode->reg] |= data;
}

void m68k_amode_0_writeword(struct m68k_amode *amode, u16 data)
{
    amode->context->regs_d[amode->reg] &= ~0xffff;
    amode->context->regs_d[amode->reg] |= data;
}

void m68k_amode_0_writelong(struct m68k_amode *amode, u32 data)
{
    amode->context->regs_d[amode->reg] = data;
}

void m68k_amode_0_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_0 = {
    m68k_amode_0_resolve,
    m68k_amode_0_readbyte,
    m68k_amode_0_readword,
    m68k_amode_0_readlong,
    m68k_amode_0_writebyte,
    m68k_amode_0_writeword,
    m68k_amode_0_writelong,
    m68k_amode_0_after,
};

void m68k_amode_1_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
}

u8 m68k_amode_1_readbyte(struct m68k_amode *amode)
{
    /* FIXME: signal exception */
    return 0;
}

u16 m68k_amode_1_readword(struct m68k_amode *amode)
{
    return (u16)amode->context->regs_a[amode->reg];
}

u32 m68k_amode_1_readlong(struct m68k_amode *amode)
{
    return amode->context->regs_a[amode->reg];
}

void m68k_amode_1_writebyte(struct m68k_amode *amode, u8 data)
{
    /* FIXME: signal exception */
}

void m68k_amode_1_writeword(struct m68k_amode *amode, u16 data)
{
    amode->context->regs_a[amode->reg] &= ~0xffff;
    amode->context->regs_a[amode->reg] |= data;
}

void m68k_amode_1_writelong(struct m68k_amode *amode, u32 data)
{
    amode->context->regs_a[amode->reg] = data;
}

void m68k_amode_1_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_1 = {
    m68k_amode_1_resolve,
    m68k_amode_1_readbyte,
    m68k_amode_1_readword,
    m68k_amode_1_readlong,
    m68k_amode_1_writebyte,
    m68k_amode_1_writeword,
    m68k_amode_1_writelong,
    m68k_amode_1_after,
};

void m68k_amode_2_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
    amode->data = context->regs_a[amode->reg];
}

u8 m68k_amode_2_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_2_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_2_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_2_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_2_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_2_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_2_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_2 = {
    m68k_amode_2_resolve,
    m68k_amode_2_readbyte,
    m68k_amode_2_readword,
    m68k_amode_2_readlong,
    m68k_amode_2_writebyte,
    m68k_amode_2_writeword,
    m68k_amode_2_writelong,
    m68k_amode_2_after,
};

void m68k_amode_3_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;
    if (size == AMS_BYTE) {
	if (amode->reg != 7) {
	    amode->flags = 1;
	} else {
	    amode->flags = 2;
	}
    } else if (size == AMS_WORD) {
	amode->flags = 2;
    } else if (size == AMS_LONG) {
	amode->flags = 4;
    } else {
	deb_printf("m68k: BUG: bogus size passed to amode 3.\n");
    }
    amode->data = context->regs_a[amode->reg];
}

u8 m68k_amode_3_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_3_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_3_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_3_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_3_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_3_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_3_after(struct m68k_amode *amode)
{
    amode->context->regs_a[amode->reg] += amode->flags;
    amode->data += amode->flags;
}

struct m68k_amode_api m68k_amode_api_3 = {
    m68k_amode_3_resolve,
    m68k_amode_3_readbyte,
    m68k_amode_3_readword,
    m68k_amode_3_readlong,
    m68k_amode_3_writebyte,
    m68k_amode_3_writeword,
    m68k_amode_3_writelong,
    m68k_amode_3_after,
};

void m68k_amode_4_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    /* FIXME: this may not do the right thing for MOVE.L A7, -(A7) */
    amode->context = context;
    if (size == AMS_BYTE) {
	if (amode->reg != 7) {
	    amode->flags = 1;
	} else {
	    amode->flags = 2;
	}
    } else if (size == AMS_WORD) {
	amode->flags = 2;
    } else if (size == AMS_LONG) {
	amode->flags = 4;
    } else {
	deb_printf("m68k: BUG: bogus size passed to amode 4.\n");
    }
    amode->data = context->regs_a[amode->reg] - amode->flags;
}

u8 m68k_amode_4_readbyte(struct m68k_amode *amode)
{
    amode->context->cycles_left -= 2;
    
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_4_readword(struct m68k_amode *amode)
{
    amode->context->cycles_left -= 2;
    
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_4_readlong(struct m68k_amode *amode)
{
    amode->context->cycles_left -= 2;
    
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_4_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_4_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_4_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_4_after(struct m68k_amode *amode)
{
    amode->context->regs_a[amode->reg] -= amode->flags;
    amode->data = amode->context->regs_a[amode->reg] - amode->flags;
}

struct m68k_amode_api m68k_amode_api_4 = {
    m68k_amode_4_resolve,
    m68k_amode_4_readbyte,
    m68k_amode_4_readword,
    m68k_amode_4_readlong,
    m68k_amode_4_writebyte,
    m68k_amode_4_writeword,
    m68k_amode_4_writelong,
    m68k_amode_4_after,
};

void m68k_amode_5_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    s16 data;
    
    amode->context = context;
    amode->data = context->regs_a[amode->reg];

    data = emu68k_opfetch_16(context);

    amode->data += (signed long)data;
}

u8 m68k_amode_5_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_5_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_5_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_5_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_5_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_5_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_5_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_5 = {
    m68k_amode_5_resolve,
    m68k_amode_5_readbyte,
    m68k_amode_5_readword,
    m68k_amode_5_readlong,
    m68k_amode_5_writebyte,
    m68k_amode_5_writeword,
    m68k_amode_5_writelong,
    m68k_amode_5_after,
};

void m68k_amode_6_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    s16 data;

    amode->context = context;
    amode->data = context->regs_a[amode->reg];

    data = emu68k_opfetch_16(context);

    amode->data += (s8)data;

    if (data & 0x0800) {
	if (data & 0x8000) {
	    /* A.L */
	    amode->data += amode->context->regs_a[(data >> 12) & 7];
	} else {
	    /* D.L */
	    amode->data += amode->context->regs_d[(data >> 12) & 7];
	}
    } else {
	if (data & 0x8000) {
	    /* A.W */
	    amode->data += (s16)amode->context->regs_a[(data >> 12) & 7];
	} else {
	    /* D.W */
	    amode->data += (s16)amode->context->regs_d[(data >> 12) & 7];
	}
    }
    
    amode->context->cycles_left -= 2;
}

u8 m68k_amode_6_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_6_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_6_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_6_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_6_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_6_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_6_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_6 = {
    m68k_amode_6_resolve,
    m68k_amode_6_readbyte,
    m68k_amode_6_readword,
    m68k_amode_6_readlong,
    m68k_amode_6_writebyte,
    m68k_amode_6_writeword,
    m68k_amode_6_writelong,
    m68k_amode_6_after,
};

void m68k_amode_7_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    s16 tmp;
    
    amode->context = context;

    tmp = emu68k_opfetch_16(context);

    amode->data = tmp; /* needed for sign extension */
}

u8 m68k_amode_7_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_7_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_7_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_7_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_7_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_7_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_7_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_7 = {
    m68k_amode_7_resolve,
    m68k_amode_7_readbyte,
    m68k_amode_7_readword,
    m68k_amode_7_readlong,
    m68k_amode_7_writebyte,
    m68k_amode_7_writeword,
    m68k_amode_7_writelong,
    m68k_amode_7_after,
};

void m68k_amode_8_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;

    amode->data = emu68k_opfetch_32(context);
}

u8 m68k_amode_8_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_8_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_8_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_8_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_8_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_8_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_8_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_8 = {
    m68k_amode_8_resolve,
    m68k_amode_8_readbyte,
    m68k_amode_8_readword,
    m68k_amode_8_readlong,
    m68k_amode_8_writebyte,
    m68k_amode_8_writeword,
    m68k_amode_8_writelong,
    m68k_amode_8_after,
};

void m68k_amode_9_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    s16 data;
    
    amode->context = context;
    amode->data = context->pc; /* FIXME: may be too small by 2 */

    data = emu68k_opfetch_16(context);

    amode->data += (signed long)data;
}

u8 m68k_amode_9_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_9_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_9_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_9_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_9_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_9_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_9_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_9 = {
    m68k_amode_9_resolve,
    m68k_amode_9_readbyte,
    m68k_amode_9_readword,
    m68k_amode_9_readlong,
    m68k_amode_9_writebyte,
    m68k_amode_9_writeword,
    m68k_amode_9_writelong,
    m68k_amode_9_after,
};

void m68k_amode_10_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    s16 data;

    amode->context = context;
    amode->data = context->pc;

    data = emu68k_opfetch_16(context);

    amode->data += (s8)data;

    if (data & 0x0800) {
	if (data & 0x8000) {
	    /* A.L */
	    amode->data += amode->context->regs_a[(data >> 12) & 7];
	} else {
	    /* D.L */
	    amode->data += amode->context->regs_d[(data >> 12) & 7];
	}
    } else {
	if (data & 0x8000) {
	    /* A.W */
	    amode->data += (s16)amode->context->regs_a[(data >> 12) & 7];
	} else {
	    /* D.W */
	    amode->data += (s16)amode->context->regs_d[(data >> 12) & 7];
	}
    }
    
    context->cycles_left -= 2;
}

u8 m68k_amode_10_readbyte(struct m68k_amode *amode)
{
    return emu68k_read_8(amode->context, amode->data);
}

u16 m68k_amode_10_readword(struct m68k_amode *amode)
{
    return emu68k_read_16(amode->context, amode->data);
}

u32 m68k_amode_10_readlong(struct m68k_amode *amode)
{
    return emu68k_read_32(amode->context, amode->data);
}

void m68k_amode_10_writebyte(struct m68k_amode *amode, u8 data)
{
    emu68k_write_8(amode->context, amode->data, data);
}

void m68k_amode_10_writeword(struct m68k_amode *amode, u16 data)
{
    emu68k_write_16(amode->context, amode->data, data);
}

void m68k_amode_10_writelong(struct m68k_amode *amode, u32 data)
{
    emu68k_write_32(amode->context, amode->data, data);
}

void m68k_amode_10_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_10 = {
    m68k_amode_10_resolve,
    m68k_amode_10_readbyte,
    m68k_amode_10_readword,
    m68k_amode_10_readlong,
    m68k_amode_10_writebyte,
    m68k_amode_10_writeword,
    m68k_amode_10_writelong,
    m68k_amode_10_after,
};

void m68k_amode_11_resolve(struct m68k_amode *amode, struct emu68k_context *context, int size)
{
    amode->context = context;

    if ((size == AMS_BYTE) || (size == AMS_WORD)) {
	amode->data = emu68k_opfetch_16(context);
    } else if (size == AMS_LONG) {
	amode->data = emu68k_opfetch_32(context);
    } else {
	deb_printf("m68k: BUG: amode 11 reports illegal size %d.\n", size);
	amode->data = 0;
    }
}

u8 m68k_amode_11_readbyte(struct m68k_amode *amode)
{
    return amode->data & 0xff;
}

u16 m68k_amode_11_readword(struct m68k_amode *amode)
{
    return amode->data;
}

u32 m68k_amode_11_readlong(struct m68k_amode *amode)
{
    return amode->data;
}

void m68k_amode_11_writebyte(struct m68k_amode *amode, u8 data)
{
    deb_printf("m68k: CPU BUG: Write to non-alterable.\n");
    abort();
}

void m68k_amode_11_writeword(struct m68k_amode *amode, u16 data)
{
    deb_printf("m68k: CPU BUG: Write to non-alterable.\n");
    abort();
}

void m68k_amode_11_writelong(struct m68k_amode *amode, u32 data)
{
    deb_printf("m68k: CPU BUG: Write to non-alterable.\n");
    abort();
}

void m68k_amode_11_after(struct m68k_amode *amode)
{
}

struct m68k_amode_api m68k_amode_api_11 = {
    m68k_amode_11_resolve,
    m68k_amode_11_readbyte,
    m68k_amode_11_readword,
    m68k_amode_11_readlong,
    m68k_amode_11_writebyte,
    m68k_amode_11_writeword,
    m68k_amode_11_writelong,
    m68k_amode_11_after,
};

struct m68k_amode m68k_get_src_amode(u16 opword)
{
    struct m68k_amode retval;
    
    if ((opword & 0x38) == 0x38) {
	if ((opword & 7) > 4) {
	    retval = m68k_amodes[12];
	} else {
	    retval = m68k_amodes[7 + (opword & 7)];
	}
    } else {
	retval = m68k_amodes[(opword & 0x38) >> 3];
    }
    retval.reg = opword & 7;
    return retval;
}

struct m68k_amode m68k_get_dest_amode(u16 opword)
{
    struct m68k_amode retval;
    
    if ((opword & 0x1c0) == 0x1c0) {
	if ((opword & 0xe00) > 0x800) {
	    retval = m68k_amodes[12];
	} else {
	    retval = m68k_amodes[7 + ((opword & 0xe00) >> 9)];
	}
    } else {
	retval = m68k_amodes[(opword & 0x1c0) >> 6];
    }
    retval.reg = (opword & 0xe00) >> 9;
    return retval;
}

/* FIXME: Why do the word stack ops use long data? */

void m68k_push_word(struct emu68k_context *context, u32 data)
{
    context->regs_a[7] -= 2;
    emu68k_write_16(context, context->regs_a[7], data);
}

u32 m68k_pop_word(struct emu68k_context *context)
{
    u16 retval;

    retval = emu68k_read_16(context, context->regs_a[7]);
    context->regs_a[7] += 2;
    
    return retval;
}

void m68k_push_long(struct emu68k_context *context, u32 data)
{
    context->regs_a[7] -= 4;
    emu68k_write_32(context, context->regs_a[7], data);
}

u32 m68k_pop_long(struct emu68k_context *context)
{
    u32 retval;

    retval = emu68k_read_32(context, context->regs_a[7]);
    context->regs_a[7] += 4;
    
    return retval;
}

#define FLAG_NZ_byte(context, data) {context->flags &= 0xfff0; if (!data) {context->flags |= 4;} if (data & 0x80) {context->flags |= 8;}}
#define FLAG_NZ_word(context, data) {context->flags &= 0xfff0; if (!data) {context->flags |= 4;} if (data & 0x8000) {context->flags |= 8;}}
#define FLAG_NZ_long(context, data) {context->flags &= 0xfff0; if (!data) {context->flags |= 4;} if (data & 0x80000000) {context->flags |= 8;}}

/* FIXME: I don't understand these next few macros */

#define FLAG_VC_ADD_byte(context, dest, src1, src2) {if (dest < src1) {context->flags |= 1;} if (((dest) ^ (src1)) & ((dest) ^ (src2)) & 0x80) {context->flags |= 2;}}
#define FLAG_VC_ADD_word(context, dest, src1, src2) {if (dest < src1) {context->flags |= 1;} if (((dest) ^ (src1)) & ((dest) ^ (src2)) & 0x8000) {context->flags |= 2;}}
#define FLAG_VC_ADD_long(context, dest, src1, src2) {if (dest < src1) {context->flags |= 1;} if (((dest) ^ (src1)) & ((dest) ^ (src2)) & 0x80000000) {context->flags |= 2;}}

#define FLAG_VC_SUB_byte(context, dest, src1, src2) {if (src1 > src2) {context->flags |= 1;} if (((dest) ^ (src1)) & ((src1) ^ (src2)) & 0x80) {context->flags |= 2;}}
#define FLAG_VC_SUB_word(context, dest, src1, src2) {if (src1 > src2) {context->flags |= 1;} if (((dest) ^ (src1)) & ((src1) ^ (src2)) & 0x8000) {context->flags |= 2;}}
#define FLAG_VC_SUB_long(context, dest, src1, src2) {if (src1 > src2) {context->flags |= 1;} if (((dest) ^ (src1)) & ((src1) ^ (src2)) & 0x80000000) {context->flags |= 2;}}

#define FLAG_X(context) if (context->flags & 1) {context->flags |= 0x0010;} else {context->flags &= 0xffef;}

void m68k_do_unimp(struct emu68k_context *context, u16 opword)
{
    deb_printf("emu68k: unimplemented opcode 0x%04hx at 0x%06x.\n", opword, context->pc);
    system_flags |= F_UNIMPL;
    /* FIXME: signal invalid opcode */
}

void m68k_do_alinetrap(struct emu68k_context *context, u16 opword)
{
    deb_printf("emu68k: A-Line trap 0x%04hx at 0x%06x.\n", opword, context->pc);
    /* FIXME: signal a-line trap */
}

void m68k_do_flinetrap(struct emu68k_context *context, u16 opword)
{
    deb_printf("emu68k: F-Line trap 0x%04hx at 0x%06x.\n", opword, context->pc);
    /* FIXME: signal f-line trap */
}

void m68k_do_SUBI_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    src.api->after(&src);
    data3 = data2 - data;
    src.api->writebyte(&src, data3);
    FLAG_NZ_byte(context, data3);
    FLAG_VC_SUB_byte(context, data3, data2, data);
}

void m68k_do_SUBI_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);
    
    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    src.api->after(&src);
    data3 = data2 - data;
    src.api->writeword(&src, data3);
    FLAG_NZ_word(context, data3);
    FLAG_VC_SUB_word(context, data3, data2, data);
}

void m68k_do_SUBI_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_32(context);

    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    src.api->after(&src);
    data3 = data2 - data;
    src.api->writelong(&src, data3);
    FLAG_NZ_long(context, data3);
    FLAG_VC_SUB_long(context, data3, data2, data);
}

void m68k_do_ADDI_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    src.api->after(&src);
    data3 = data2 + data;
    src.api->writebyte(&src, data3);
    FLAG_NZ_byte(context, data3);
    FLAG_VC_ADD_byte(context, data3, data2, data);
}

void m68k_do_ADDI_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    src.api->after(&src);
    data3 = data2 + data;
    src.api->writeword(&src, data3);
    FLAG_NZ_word(context, data3);
    FLAG_VC_ADD_word(context, data3, data2, data);
}

void m68k_do_ADDI_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_32(context);
    
    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    src.api->after(&src);
    data3 = data2 + data;
    src.api->writelong(&src, data3);
    FLAG_NZ_long(context, data3);
    FLAG_VC_ADD_long(context, data3, data2, data);
}

void m68k_do_ANDI_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);
    
    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    src.api->after(&src);
    data3 = data2 & data;
    src.api->writebyte(&src, data3);
    FLAG_NZ_byte(context, data3);
}

void m68k_do_ANDI_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    src.api->after(&src);
    data3 = data2 & data;
    src.api->writeword(&src, data3);
    FLAG_NZ_word(context, data3);
}

void m68k_do_ANDI_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_32(context);

    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    src.api->after(&src);
    data3 = data2 & data;
    src.api->writelong(&src, data3);
    FLAG_NZ_long(context, data3);

    context->cycles_left -= 4;
}

void m68k_do_AND_d_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);

    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data2 & data;
    FLAG_NZ_byte(context, data3);
    context->regs_d[(opword >> 9) & 7] &= 0xffffff00;
    context->regs_d[(opword >> 9) & 7] |= data3;
	
    src.api->after(&src);
}

void m68k_do_AND_d_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);

    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 & data;
    FLAG_NZ_word(context, data3);
    context->regs_d[(opword >> 9) & 7] &= 0xffff0000;
    context->regs_d[(opword >> 9) & 7] |= data3;
    
    src.api->after(&src);
}

void m68k_do_AND_d_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);

    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data2 & data;
    FLAG_NZ_long(context, data3);
    context->regs_d[(opword >> 9) & 7] = data3;
    
    src.api->after(&src);

    context->cycles_left -= 4;
}

void m68k_do_AND_e_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data2 & data;
    FLAG_NZ_byte(context, data3);
    src.api->writebyte(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_AND_e_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 & data;
    FLAG_NZ_word(context, data3);
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_AND_e_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data2 & data;
    FLAG_NZ_long(context, data3);
    src.api->writelong(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ORI_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    src.api->after(&src);
    data3 = data2 | data;
    src.api->writebyte(&src, data3);
    FLAG_NZ_byte(context, data3);
}

void m68k_do_ORI_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    src.api->after(&src);
    data3 = data2 | data;
    src.api->writeword(&src, data3);
    FLAG_NZ_word(context, data3);
}

void m68k_do_ORI_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_32(context);

    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    src.api->after(&src);
    data3 = data2 | data;
    src.api->writelong(&src, data3);
    FLAG_NZ_long(context, data3);
}

void m68k_do_OR_d_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data2 | data;
    FLAG_NZ_byte(context, data3);
    context->regs_d[(opword >> 9) & 7] &= 0xffffff00;
    context->regs_d[(opword >> 9) & 7] |= data3;
    
    src.api->after(&src);
}

void m68k_do_OR_d_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 | data;
    FLAG_NZ_word(context, data3);
    context->regs_d[(opword >> 9) & 7] &= 0xffff0000;
    context->regs_d[(opword >> 9) & 7] |= data3;
    
    src.api->after(&src);
}

void m68k_do_OR_d_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);

    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data2 | data;
    FLAG_NZ_long(context, data3);
    context->regs_d[(opword >> 9) & 7] = data3;
    
    src.api->after(&src);
}

void m68k_do_OR_e_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data2 | data;
    FLAG_NZ_byte(context, data3);
    src.api->writebyte(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_OR_e_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 | data;
    FLAG_NZ_word(context, data3);
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_OR_e_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data2 | data;
    FLAG_NZ_long(context, data3);
    src.api->writelong(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_CMPI_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    src.api->after(&src);
    data3 = data2 - data;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_SUB_byte(context, data3, data2, data);
}

void m68k_do_CMPI_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = emu68k_opfetch_16(context);

    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    src.api->after(&src);
    data3 = data2 - data;
    FLAG_NZ_word(context, data3);
    FLAG_VC_SUB_word(context, data3, data2, data);
}

void m68k_do_CMPI_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    struct m68k_amode src;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    data = emu68k_opfetch_32(context);
    
    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    src.api->after(&src);
    data3 = data2 - data;
    FLAG_NZ_long(context, data3);
    FLAG_VC_SUB_long(context, data3, data2, data);
}

void m68k_do_MOVE_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    u8 data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword);

    if (!(AMODE_IS(dest, AMT_DA) && (src.type))) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_BYTE);
    dest.api->resolve(&dest, context, AMS_BYTE);
    data = src.api->readbyte(&src);
    dest.api->writebyte(&dest, data);
    src.api->after(&src);
    dest.api->after(&dest);
    FLAG_NZ_byte(context, data);
}

void m68k_do_MOVE_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    u16 data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword);

    if (!(AMODE_IS(dest, AMT_DA) && (src.type))) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_WORD);
    dest.api->resolve(&dest, context, AMS_WORD);
    data = src.api->readword(&src);
    dest.api->writeword(&dest, data);
    src.api->after(&src);
    dest.api->after(&dest);
    FLAG_NZ_word(context, data);
}

void m68k_do_MOVEA_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    s32 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    data = (s16)src.api->readword(&src);
    src.api->after(&src);
    
    context->regs_a[(opword >> 9) & 7] = data;
}

void m68k_do_MOVE_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    struct m68k_amode dest;
    u32 data;
    
    src = m68k_get_src_amode(opword);
    dest = m68k_get_dest_amode(opword);

    if (!(AMODE_IS(dest, AMT_DA) && (src.type))) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_LONG);
    dest.api->resolve(&dest, context, AMS_LONG);
    data = src.api->readlong(&src);
    dest.api->writelong(&dest, data);
    src.api->after(&src);
    dest.api->after(&dest);
    FLAG_NZ_long(context, data);
}

void m68k_do_MOVEA_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    data = src.api->readlong(&src);
    src.api->after(&src);
    
    context->regs_a[(opword >> 9) & 7] = data;
}

void m68k_do_CLR_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    src.api->writebyte(&src, 0);
    src.api->after(&src);
    FLAG_NZ_byte(context, 0);
}

void m68k_do_CLR_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    src.api->writeword(&src, 0);
    src.api->after(&src);
    FLAG_NZ_word(context, 0);
}

void m68k_do_CLR_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    src.api->writelong(&src, 0);
    src.api->after(&src);
    FLAG_NZ_long(context, 0);

    context->cycles_left -= 2;
}

void m68k_do_TST_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    data = src.api->readbyte(&src);
    src.api->after(&src);
    FLAG_NZ_byte(context, data);
}

void m68k_do_TST_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    data = src.api->readword(&src);
    src.api->after(&src);
    FLAG_NZ_word(context, data);
}

void m68k_do_TST_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    data = src.api->readlong(&src);
    src.api->after(&src);
    FLAG_NZ_long(context, data);
}

void m68k_do_NOT_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    data = src.api->readbyte(&src);
    data ^= 0xff;
    src.api->writebyte(&src, data);
    src.api->after(&src);
    FLAG_NZ_byte(context, data);
}

void m68k_do_NOT_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    data = src.api->readword(&src);
    data ^= 0xffff;
    src.api->writeword(&src, data);
    src.api->after(&src);
    FLAG_NZ_word(context, data);
}

void m68k_do_NOT_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    data = src.api->readlong(&src);
    data ^= 0xffffffff;
    src.api->writelong(&src, data);
    src.api->after(&src);
    FLAG_NZ_long(context, data);
    context->cycles_left -= 2;
}

void m68k_do_TAS(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    data = src.api->readbyte(&src);
    src.api->writebyte(&src, data | 0x80);
    src.api->after(&src);
    FLAG_NZ_byte(context, data);
}

void m68k_handle_Bcc(struct emu68k_context *context, u16 opword, int take_branch)
{
    s16 offset;
    
    if (!take_branch) {
	if (!(opword & 0xff)) {
	    offset = emu68k_opfetch_16(context);
	}
	context->cycles_left -= 4;
    } else {
	offset = emu68k_opfetch_16(context);
	context->pc -= 2; /* cheating, but what can you do? */

	if (opword & 0xff) {
	    offset = (s8)opword;
	}

	context->pc += offset;
	context->cycles_left -= 2;
    }
}

void m68k_do_BRA(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, 1);
}

void m68k_do_BCC(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, !(context->flags & 0x01));
}

void m68k_do_BCS(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, context->flags & 0x01);
}

void m68k_do_BNE(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, !(context->flags & 0x04));
}

void m68k_do_BEQ(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, context->flags & 0x04);
}

void m68k_do_BPL(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, !(context->flags & 0x08));
}

void m68k_do_BMI(struct emu68k_context *context, u16 opword)
{
    m68k_handle_Bcc(context, opword, context->flags & 0x08);
}

void m68k_do_BSR(struct emu68k_context *context, u16 opword)
{
    s16 offset;

    if (opword & 0xff) {
	offset = ((s8)opword);

	m68k_push_long(context, context->pc);
    } else {
	offset = emu68k_opfetch_16(context);

	m68k_push_long(context, context->pc);
	
	context->pc -= 2;
    }
    
    context->pc += offset;
}

void m68k_do_LEA(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_CONTROL)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BOGUS);
    context->regs_a[(opword >> 9) & 7] = src.data;
    src.api->after(&src);
}

void m68k_do_MOVEQ(struct emu68k_context *context, u16 opword)
{
    s32 data;
    
    data = (s8)(opword & 0xff); /* NOTE: this had better work */
    context->regs_d[(opword >> 9) & 7] = data;
    FLAG_NZ_long(context, data);
}

void m68k_do_DBF(struct emu68k_context *context, u16 opword)
{
    s16 offset;
    u16 tmp;
    u32 new_pc;

    new_pc = context->pc;
    offset = emu68k_opfetch_16(context);
    new_pc += offset;
    
    tmp = context->regs_d[opword & 7] & 0xffff;
    tmp--;
    context->regs_d[opword & 7] &= 0xffff0000;
    context->regs_d[opword & 7] |= tmp;
    
    if (tmp == 0xffff) {
	emu68k_read_16(context, new_pc); /* Stupid pipeline */
    } else {
	context->pc = new_pc;
    }
    
    context->cycles_left -= 2;
}

void m68k_do_SF(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    src.api->writebyte(&src, 0);
    src.api->after(&src);
}

void m68k_do_BTST_dyn(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 tmp;
    u32 data;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    tmp = context->regs_d[(opword >> 9) & 7];
    
    if (src.api == &m68k_amode_api_0) {
	src.api->resolve(&src, context, AMS_LONG);
	data = src.api->readlong(&src);
	tmp &= 0x1f;
    } else {
	src.api->resolve(&src, context, AMS_BYTE);
	data = src.api->readbyte(&src);
	tmp &= 7;
    }
    src.api->after(&src);
    if (data & (1 << tmp)) {
	context->flags &= ~4;
    } else {
	context->flags |= 4;
    }
    context->cycles_left -= 2;
}

void m68k_do_BTST_stat(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 tmp;
    u32 data;

    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    tmp = emu68k_opfetch_16(context);
    
    if (src.api == &m68k_amode_api_0) {
	src.api->resolve(&src, context, AMS_LONG);
	data = src.api->readlong(&src);
	tmp &= 0x1f;
    } else {
	src.api->resolve(&src, context, AMS_BYTE);
	data = src.api->readbyte(&src);
	tmp &= 7;
    }
    src.api->after(&src);
    if (data & (1 << tmp)) {
	context->flags &= ~4;
    } else {
	context->flags |= 4;
    }
}

void m68k_do_SUB_reg_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }

    data = context->regs_d[(opword >> 9) & 7];
	
    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    src.api->after(&src);
    
    data3 = data - data2;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_SUB_byte(context, data3, data2, data);
    FLAG_X(context);
    
    context->regs_d[(opword >> 9) & 7] &= ~0xff;
    context->regs_d[(opword >> 9) & 7] |= data3;
}

void m68k_do_SUB_reg_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }

    data = context->regs_d[(opword >> 9) & 7];
	
    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    src.api->after(&src);
    
    data3 = data - data2;
    FLAG_NZ_word(context, data3);
    FLAG_VC_SUB_word(context, data3, data2, data);
    FLAG_X(context);
    
    context->regs_d[(opword >> 9) & 7] &= ~0xffff;
    context->regs_d[(opword >> 9) & 7] |= data3;
}

void m68k_do_SUBA_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    s16 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_WORD);
    data = src.api->readword(&src);
    src.api->after(&src);
    context->regs_a[(opword >> 9) & 7] -= data;
    context->cycles_left -= 4;
}

void m68k_do_SUBA_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_LONG);
    data = src.api->readlong(&src);
    src.api->after(&src);
    context->regs_a[(opword >> 9) & 7] -= data;
    context->cycles_left -= 4;
}

void m68k_do_SUBQ_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    data3 = data2 - data;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_SUB_byte(context, data3, data2, data);
    FLAG_X(context);
    src.api->writebyte(&src, data3);
    src.api->after(&src);
}

void m68k_do_SUBQ_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_ALTERABLE)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    data3 = data2 - data;
    FLAG_NZ_word(context, data3);
    FLAG_VC_SUB_word(context, data3, data2, data);
    FLAG_X(context);
    src.api->writeword(&src, data3);
    src.api->after(&src);
}

void m68k_do_SUBQ_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_ALTERABLE)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    data3 = data2 - data;
    FLAG_NZ_long(context, data3);
    FLAG_VC_SUB_long(context, data3, data2, data);
    src.api->writelong(&src, data3);
    src.api->after(&src);
}

void m68k_do_SUBQ_An(struct emu68k_context *context, u16 opword)
{
    u32 data;
    
    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    context->regs_a[opword & 7] -= data;
    context->cycles_left -= 4;
}

void m68k_do_ADDQ_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    src.api->resolve(&src, context, AMS_BYTE);
    data2 = src.api->readbyte(&src);
    data3 = data2 + data;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_ADD_byte(context, data3, data2, data);
    src.api->writebyte(&src, data3);
    src.api->after(&src);
}

void m68k_do_ADDQ_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_ALTERABLE)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    src.api->resolve(&src, context, AMS_WORD);
    data2 = src.api->readword(&src);
    data3 = data2 + data;
    FLAG_NZ_word(context, data3);
    FLAG_VC_ADD_word(context, data3, data2, data);
    FLAG_X(context);
    src.api->writeword(&src, data3);
    src.api->after(&src);
}

void m68k_do_ADDQ_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_ALTERABLE)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    data = (opword >> 9) & 7;
    if (!data) {
	data = 8;
    }
    src.api->resolve(&src, context, AMS_LONG);
    data2 = src.api->readlong(&src);
    data3 = data2 + data;
    FLAG_NZ_long(context, data3);
    FLAG_VC_ADD_long(context, data3, data2, data);
    src.api->writelong(&src, data3);
    src.api->after(&src);
}

void m68k_do_MOVE_to_CCR(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    
    src = m68k_get_src_amode(opword);
    
    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    data = src.api->readword(&src);
    src.api->after(&src);
    
    context->flags &= 0xffe0;
    context->flags |= data & 0x001f;

    context->cycles_left -= 8;
}

void m68k_do_MOVE_to_SR(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;

    src = m68k_get_src_amode(opword);
    
    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    if (!(context->flags & 0x2000)) {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_to_SR(): TRAP!\n");
	return;
    }

    src.api->resolve(&src, context, AMS_WORD);
    data = src.api->readword(&src);
    src.api->after(&src);
    context->flags = data;
    if (!(data & 0x2000)) {
	u32 data2;
	data2 = context->regs_a[7];
	context->regs_a[7] = context->other_sp;
	context->other_sp = data2;
    }
    context->cycles_left -= 8;
}

void m68k_do_MOVE_from_SR(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_WORD);
    src.api->writeword(&src, context->flags);
    src.api->after(&src);

    context->cycles_left -= 2;
}

void m68k_do_MOVEM_RM_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 reglist;
    u16 data;
    int i;
    
    src = m68k_get_src_amode(opword);

    if (!(AMODE_IS(src, AMT_DA) || (src.api == &m68k_amode_api_4))) {
	m68k_do_unimp(context, opword);
	return;
    }

    reglist = emu68k_opfetch_16(context);
    src.api->resolve(&src, context, AMS_WORD);
    if (src.api == &m68k_amode_api_4) {
	for (i = 0; i < 16; i++) {
	    if (reglist & (1 << i)) {
		if (i & 8) {
		    data = context->regs_d[(7 - i) & 7];
		} else {
		    data = context->regs_a[(7 - i) & 7];
		}
		src.api->writeword(&src, data);
		src.api->after(&src);
	    }
	}
    } else {
	for (i = 0; i < 16; i++) {
	    if (reglist & (1 << i)) {
		if (i & 8) {
		    data = context->regs_a[i & 7];
		} else {
		    data = context->regs_d[i & 7];
		}
		src.api->writeword(&src, data);
		src.api->after(&src);
		if (src.api != &m68k_amode_api_3) {
		    src.data += 2;
		}
	    }
	}
    }
}

void m68k_do_MOVEM_RM_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u16 reglist;
    int i;

    src = m68k_get_src_amode(opword);

    if (!(AMODE_IS(src, AMT_DA) || (src.api == &m68k_amode_api_4))) {
	m68k_do_unimp(context, opword);
	return;
    }

    reglist = emu68k_opfetch_16(context);
    src.api->resolve(&src, context, AMS_LONG);
    if (src.api == &m68k_amode_api_4) {
	for (i = 0; i < 16; i++) {
	    if (reglist & (1 << i)) {
		if (i & 8) {
		    data = context->regs_d[(7 - i) & 7];
		} else {
		    data = context->regs_a[(7 - i) & 7];
		}
		src.api->writelong(&src, data);
		src.api->after(&src);
	    }
	}
    } else {
	for (i = 0; i < 16; i++) {
	    if (reglist & (1 << i)) {
		if (i & 8) {
		    data = context->regs_a[i & 7];
		} else {
		    data = context->regs_d[i & 7];
		}
		src.api->writelong(&src, data);
		src.api->after(&src);
		if (src.api != &m68k_amode_api_3) {
		    src.data += 4;
		}
	    }
	}
    }
}

void m68k_do_MOVEM_MR_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    s16 data;
    u16 reglist;
    int i;
    
    src = m68k_get_src_amode(opword);

    if (!(AMODE_IS(src, AMT_CONTROL) || (src.api == &m68k_amode_api_3))) {
	m68k_do_unimp(context, opword);
	return;
    }

    reglist = emu68k_opfetch_16(context);
    src.api->resolve(&src, context, AMS_WORD);
    for (i = 0; i < 16; i++) {
	if (reglist & (1 << i)) {
	    data = src.api->readword(&src);
	    if (i & 8) {
		context->regs_a[i & 7] = data;
	    } else {
		context->regs_d[i & 7] = data;
	    }
	    src.api->after(&src);
	    if (src.api != &m68k_amode_api_3) {
		src.data += 2;
	    }
	}
    }
}

void m68k_do_MOVEM_MR_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u16 reglist;
    int i;
    
    src = m68k_get_src_amode(opword);

    if (!(AMODE_IS(src, AMT_CONTROL) || (src.api == &m68k_amode_api_3))) {
	m68k_do_unimp(context, opword);
	return;
    }

    reglist = emu68k_opfetch_16(context);
    src.api->resolve(&src, context, AMS_LONG);
    for (i = 0; i < 16; i++) {
	if (reglist & (1 << i)) {
	    data = src.api->readlong(&src);
	    if (i & 8) {
		context->regs_a[i & 7] = data;
	    } else {
		context->regs_d[i & 7] = data;
	    }
	    src.api->after(&src);
	    if (src.api != &m68k_amode_api_3) {
		src.data += 4;
	    }
	}
    }
}

void m68k_do_MOVE_to_USP(struct emu68k_context *context, u16 opword)
{
    if (!context->flags & 0x2000) {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_to_USP(): TRAP!\n");
	return;
    }
    
    context->other_sp = context->regs_a[opword & 7];
}

void m68k_do_MOVE_from_USP(struct emu68k_context *context, u16 opword)
{
    if (!context->flags & 0x2000) {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_from_USP(): TRAP!\n");
	return;
    }
    
    context->regs_a[opword & 7] = context->other_sp;
}

void m68k_do_ADD_d_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data2 + data;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_ADD_byte(context, data3, data2, data);
    FLAG_X(context);
    context->regs_d[(opword >> 9) & 7] &= 0xffffff00;
    context->regs_d[(opword >> 9) & 7] |= data3;
    
    src.api->after(&src);
}

void m68k_do_ADD_d_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 + data;
    FLAG_NZ_word(context, data3);
    FLAG_VC_ADD_word(context, data3, data2, data);
    FLAG_X(context);
    context->regs_d[(opword >> 9) & 7] &= 0xffff0000;
    context->regs_d[(opword >> 9) & 7] |= data3;
    
    src.api->after(&src);
}

void m68k_do_ADD_d_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data2 + data;
    FLAG_NZ_long(context, data3);
    FLAG_VC_ADD_long(context, data3, data2, data);
    FLAG_X(context);
    context->regs_d[(opword >> 9) & 7] = data3;
    
    src.api->after(&src);

    context->cycles_left -= 4;
}

void m68k_do_ADD_e_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data2 + data;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_ADD_byte(context, data3, data2, data);
    FLAG_X(context);
    src.api->writebyte(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ADD_e_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 + data;
    FLAG_NZ_word(context, data3);
    FLAG_VC_ADD_word(context, data3, data2, data);
    FLAG_X(context);
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ADD_e_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data2 + data;
    FLAG_NZ_long(context, data3);
    FLAG_VC_ADD_long(context, data3, data2, data);
    FLAG_X(context);
    src.api->writelong(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ADDA_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    s32 data;
    s16 data2;
    s32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_a[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data2 + data;
    context->regs_a[(opword >> 9) & 7] = data3;
    
    src.api->after(&src);
    
    context->cycles_left -= 4;
}

void m68k_do_RTS(struct emu68k_context *context, u16 opword)
{
    context->pc = m68k_pop_long(context);
    context->cycles_left -= 4;
}

void m68k_do_RTE(struct emu68k_context *context, u16 opword)
{
    u16 new_flags;
    
    if (!(context->flags & 0x2000)) {
	/* FIXME: raise TRAP */
	deb_printf("m68k_do_MOVE_from_USP(): TRAP!\n");
	return;
    }
    
    new_flags = m68k_pop_word(context);
    context->pc = m68k_pop_long(context);
    if ((new_flags ^ context->flags) & 0x2000) {
	u32 tmp;
	
	tmp = context->regs_a[7];
	context->regs_a[7] = context->other_sp;
	context->other_sp = tmp;
    }
    context->flags = new_flags;
    context->cycles_left -= 4;
}

void m68k_do_NOP(struct emu68k_context *context, u16 opword)
{
}

void m68k_do_JMP(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_CONTROL)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BOGUS);
    context->pc = src.data;
    src.api->after(&src);
    context->cycles_left -= 4;
}

void m68k_do_JSR(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_CONTROL)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BOGUS);
    m68k_push_long(context, context->pc);
    context->pc = src.data;
    src.api->after(&src);
    context->cycles_left -= 4;
}

void m68k_do_LINK(struct emu68k_context *context, u16 opword)
{
    s16 tmp;

    tmp = emu68k_opfetch_16(context);

    m68k_push_long(context, context->regs_a[opword & 7]);
    context->regs_a[opword & 7] = context->regs_a[7];
    context->regs_a[7] += tmp; /* FIXME: make sure this sign-extends */
}

void m68k_do_UNLK(struct emu68k_context *context, u16 opword)
{
    context->regs_a[7] = context->regs_a[opword & 7];
    context->regs_a[opword & 7] = m68k_pop_long(context);
}

void m68k_do_CMP_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DATA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data - data2;
    FLAG_NZ_byte(context, data3);
    FLAG_VC_SUB_byte(context, data3, data2, data);
    
    src.api->after(&src);
}

void m68k_do_CMP_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);

    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data - data2;
    FLAG_NZ_word(context, data3);
    FLAG_VC_SUB_word(context, data3, data2, data);
    
    src.api->after(&src);
}

void m68k_do_CMP_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!src.type) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_LONG);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data - data2;
    FLAG_NZ_long(context, data3);
    FLAG_VC_SUB_long(context, data3, data2, data);
    
    src.api->after(&src);
}

void m68k_do_EOR_byte(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u8 data;
    u8 data2;
    u8 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_BYTE);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readbyte(&src);
    data3 = data ^ data2;
    FLAG_NZ_byte(context, data3);
    
    src.api->writebyte(&src, data3);
    src.api->after(&src);
}

void m68k_do_EOR_word(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u16 data;
    u16 data2;
    u16 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_WORD);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readword(&src);
    data3 = data ^ data2;
    FLAG_NZ_word(context, data3);
    
    src.api->writeword(&src, data3);
    src.api->after(&src);
}

void m68k_do_EOR_long(struct emu68k_context *context, u16 opword)
{
    struct m68k_amode src;
    u32 data;
    u32 data2;
    u32 data3;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }

    src.api->resolve(&src, context, AMS_LONG);
    
    data = context->regs_d[(opword >> 9) & 7];
    data2 = src.api->readlong(&src);
    data3 = data ^ data2;
    FLAG_NZ_long(context, data3);
    
    src.api->writelong(&src, data3);
    src.api->after(&src);
    
    context->cycles_left -= 4;
}

void m68k_do_LSL_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (0x80 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_LSL_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    
    FLAG_NZ_word(context, data3);

    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 1;
    }

    if (data) {
        FLAG_X(context);
    }

    context->regs_d[opword & 7] &= ~0xffff;
    context->regs_d[opword & 7] |= data3;

    context->cycles_left -= 2 + (data + data);
}

void m68k_do_LSL_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    
    FLAG_NZ_long(context, data3);

    if (data2 & (0x80000000 >> (data - 1))) {
	context->flags |= 1;
    }

    if (data) {
	FLAG_X(context);
    }
    
    context->regs_d[opword & 7] = data3;

    context->cycles_left -= 4 + (data + data);
}

void m68k_do_LSL_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 << data;
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_LSR_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_LSR_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 1;
    }

    if (data) {
        FLAG_X(context);
    }

    context->regs_d[opword & 7] &= 0xffff0000;
    context->regs_d[opword & 7] |= data3;

    context->cycles_left -= 2 + (data + data);
}

void m68k_do_LSR_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 1;
    }
    
    if (data) {
        FLAG_X(context);
    }

    context->regs_d[opword & 7] = data3;

    context->cycles_left -= 4 + (data + data);
}

void m68k_do_LSR_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 >> data;
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ASR_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;

    if (data2 & 0x80) {
	data3 |= (0xff << (8 - data));
    }
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ASR_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    if (data2 & 0x8000) {
	data3 |= (0xff00 << (8 - data));
    }
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 1;
    }

    if (data) {
	FLAG_X(context);
    }

    context->regs_d[opword & 7] &= 0xffff0000;
    context->regs_d[opword & 7] |= data3;

    context->cycles_left -= 2 + (data + data);
}

void m68k_do_ASR_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    
    if (data2 & 0x80000000) {
	data3 |= (0xff000000 << (8 - data));
    }
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 1;
    }

    if (data) {
	FLAG_X(context);
    }
	
    context->regs_d[opword & 7] = data3;

    context->cycles_left -= 4 + (data + data);
}

void m68k_do_ASR_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 >> data;
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ROL_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (8 - data);
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (0x80 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROL_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (16 - data);
    
    FLAG_NZ_word(context, data3);

    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }

    ((u16)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROL_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (32 - data);
    
    FLAG_NZ_long(context, data3);

    if (data2 & (0x80000000 >> (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROL_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 << data;
    data3 |= data2 >> (16 - data);
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ROR_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (8 - data);
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROR_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (16 - data);
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }

    ((u16)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROR_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (32 - data);
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROR_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 >> data;
    data3 |= data2 << (16 - data);
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ROXL_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (7 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (0x80 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXL_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (15 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_word(context, data3);

    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }

    ((u16)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXL_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 << data;
    data3 |= data2 >> (31 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_long(context, data3);

    if (data2 & (0x80000000 >> (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROXL_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 << data;
    data3 |= data2 >> (15 - data);
    if (context->flags & 0x10) {
	data3 |= 1 << (data - 1);
    }
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (0x8000 >> (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

void m68k_do_ROXR_r_byte(struct emu68k_context *context, u16 opword)
{
    u8 data;
    u8 data2;
    u8 data3;

    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (7 - data);
    if (context->flags & 0x10) {
	data3 |= 0x80 >> (data - 1);
    }
    
    FLAG_NZ_byte(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    ((u8)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXR_r_word(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (15 - data);
    if (context->flags & 0x10) {
	data3 |= 0x8000 >> (data - 1);
    }
    
    FLAG_NZ_word(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }

    ((u16)context->regs_d[opword & 7]) = data3;
}

void m68k_do_ROXR_r_long(struct emu68k_context *context, u16 opword)
{
    u32 data;
    u32 data2;
    u32 data3;
    
    if (opword & 0x0020) {
	data = context->regs_d[(opword >> 9) & 7] & 0x3f;
    } else {
	data = (opword >> 9) & 7;
	if (!data) {
	    data = 8;
	}
    }
    
    data2 = context->regs_d[opword & 7];

    data3 = data2 >> data;
    data3 |= data2 << (31 - data);
    if (context->flags & 0x10) {
	data3 |= 0x80000000 >> (data - 1);
    }
    
    FLAG_NZ_long(context, data3);

    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
	
    context->regs_d[opword & 7] = data3;
}

void m68k_do_ROXR_m(struct emu68k_context *context, u16 opword)
{
    u16 data;
    u16 data2;
    u16 data3;
    struct m68k_amode src;
    
    src = m68k_get_src_amode(opword);

    if (!AMODE_IS(src, AMT_DA)) {
	m68k_do_unimp(context, opword);
	return;
    }
    
    src.api->resolve(&src, context, AMS_WORD);
    
    data = 1;
    data2 = src.api->readword(&src);
    data3 = data2 >> data;
    data3 |= data2 << (15 - data);
    if (context->flags & 0x10) {
	data3 |= 0x8000 >> (data - 1);
    }
    
    FLAG_NZ_word(context, data3);
    
    if (data2 & (1 << (data - 1))) {
	context->flags |= 0x11;
    }
    
    src.api->writeword(&src, data3);
    
    src.api->after(&src);
}

/*
 * $Log: emu68k.c,v $
 * Revision 1.31  1999/12/27 00:58:52  nyef
 * made it easy to re-enable all disabled instructions at once
 * fixed and enabled a handful more instructions
 *
 * Revision 1.30  1999/12/25 05:13:04  nyef
 * debugged and enabled CLR.B, CLR.W, ADDQ.W, AND.L, AND.L, ADD.L, LSR.W,
 *     LSR.L, and LSL.W
 *
 * Revision 1.29  1999/12/19 00:02:38  nyef
 * enabled BCC, BCS, CMP.W, and CMP.L
 *
 * Revision 1.28  1999/12/18 23:31:21  nyef
 * enabled the remaining MOVEM instructions
 *
 * Revision 1.27  1999/12/18 23:01:07  nyef
 * enabled LINK and UNLK instructions
 * fixed 16-bit write cycle cost
 *
 * Revision 1.26  1999/12/18 22:15:12  nyef
 * cleaned up a lot of stuff in the opcode handlers
 *
 * Revision 1.25  1999/12/18 20:31:06  nyef
 * fixed SUBQ.B, SUBQ.W, and SUBQ.[WL] An
 *
 * Revision 1.24  1999/12/18 18:54:55  nyef
 * disabled any instruction there is no test case for
 * added more cycle counting code
 * cleaned up some debug output
 * cleaned up an opfetch
 *
 * Revision 1.23  1999/12/18 04:24:27  nyef
 * cleaned up some stuff with the MOVEA instructions
 *
 * Revision 1.22  1999/12/18 04:18:44  nyef
 * fixed sign extension in MOVEA.W emulation
 *
 * Revision 1.21  1999/12/18 04:08:52  nyef
 * added SUB.B and SUB.W instruction emulation
 *
 * Revision 1.20  1999/12/18 03:05:50  nyef
 * added ADDA.W instruction emulation
 *
 * Revision 1.19  1999/12/18 02:43:02  nyef
 * changed most variable declarations to use the new type interface
 *
 * Revision 1.18  1999/12/18 01:52:30  nyef
 * changed ADD instructions to evaluate the X flag
 *
 * Revision 1.17  1999/12/17 02:48:20  nyef
 * added BPL and BMI instructions
 *
 * Revision 1.16  1999/12/17 02:21:15  nyef
 * added EOR instruction emulation
 *
 * Revision 1.15  1999/12/17 01:45:22  nyef
 * fixed a typo in m68k_do_unimp()
 *
 * Revision 1.14  1999/12/16 05:03:43  nyef
 * fixed cycle timing and other suchwhat in the DBF instruction
 *
 * Revision 1.13  1999/12/16 04:47:57  nyef
 * refactored and added cycle counts to the Bcc family of instructions
 *
 * Revision 1.12  1999/12/15 03:49:04  nyef
 * added implementation of the NOT instructions
 *
 * Revision 1.11  1999/12/15 03:06:25  nyef
 * fixed a major bug in the DBF instruction
 *
 * Revision 1.10  1999/12/15 02:32:31  nyef
 * fixed a bug in the stack pop long routine
 * added more cycle timing data
 *
 * Revision 1.9  1999/12/15 01:56:55  nyef
 * fixed a bug in the new 32-bit write routine
 *
 * Revision 1.8  1999/12/15 00:56:28  nyef
 * changed the write sequence cycle count to reflect the
 *   official motorola docu
 *
 * Revision 1.7  1999/12/13 03:14:38  nyef
 * fixed address calculation for amode 10 (PC relative indexed)
 * added more cycle counting code
 *
 * Revision 1.6  1999/12/12 21:49:44  nyef
 * created procedures to handle opword fetches
 * changed several opfetch operations to use the new opfetch code
 * added more cycle counting code
 *
 * Revision 1.5  1999/12/12 17:28:13  nyef
 * created procedures to handle reading and writing memory
 * changed a lot of memory accesses to use the new memory access code
 * started adding code for cycle counting
 *
 * Revision 1.4  1999/09/08 01:05:06  nyef
 * added numerous instructions, cleaned up numerous bugs
 *
 * Revision 1.3  1999/08/07 15:37:45  nyef
 * added the final amode, some debugging stuff, and one less bug
 *
 * Revision 1.2  1999/06/19 18:44:27  nyef
 * added preliminary implementation of amode 6 (register indirect index)
 *
 * Revision 1.1  1999/04/17 22:24:55  nyef
 * Initial revision
 *
 */
